<div class="pt-[4.5rem] md:pt-24 lg:pt-32 xl:pt-40">
  <!--Bloc image mobile-->
  <div class="w-full h-44 md:hidden relative">
    <div class="absolute inset-0 bg-cover bg-center" [ngStyle]="{'background-image': 'url(' + merchantImageUrl + ')'}">
    </div>

    <div class="absolute inset-0 flex items-end justify-end p-4">
      <button (click)="openGallery()" class="bg-white text-black px-4 py-2 text-sm rounded-full">
        Voir toutes les photos <i class="fa-solid fa-camera ml-1"></i>
      </button>
    </div>
  </div>
  <!---->

  <div class="py-5 px-4">
    <div class="flex justify-center gap-5 items-center">
      <p class="text-center text-xl md:text-3xl lg:text-4xl">{{merchant?.merchant_name}}</p>
    </div>

    <div class="flex justify-center gap-2 items-center my-2">
      <app-star-rating [rating]="averageRating"></app-star-rating>
      <p class="font-medium">{{averageRating}}/5</p>
    </div>
    
    <!--Bloc image desktop and tablet-->
    <div class="hidden md:flex justify-center gap-5 mt-7 mb-20 lg:mx-16 xl:mx-40">
      <div class="w-3/4 drop-shadow-xl h-72 xl:h-96 relative hidden lg:flex">
        <div class="absolute inset-0 bg-cover bg-center" [ngStyle]="{'background-image': 'url(' + secondMerchantImageUrl + ')'}">
        </div>
      </div>

      <div class="w-3/4 drop-shadow-xl h-72 xl:h-96 relative">
        <div class="absolute inset-0 bg-cover bg-center" [ngStyle]="{'background-image': 'url(' + merchantImageUrl + ')'}">
        </div>
    
        <div class="absolute inset-0 flex items-end justify-end p-4">
          <button (click)="openGallery()" class="bg-white text-black px-4 py-2 text-sm rounded-full">
            Voir toutes les photos <i class="fa-solid fa-camera ml-1"></i>
          </button>
        </div>
      </div>
    </div>
    <!---->

    <div class="mt-5 lg:mx-16 xl:mx-40">
      <p class="text-lg md:text-2xl xl:text-4xl md:mb-3 xl:mb-7">Présentation de l'établissement</p>
      <p class="text-sm xl:text-base font-light">{{merchant?.merchant_description}}</p>
    </div>
  </div>

  <div class="md:flex md:flex-row-reverse justify-center lg:mx-16 xl:mx-40">
    <div class="bg-[#807F4B] text-white rounded-xl xl:pt-8 xl:pb-5 xl:px-8 py-5 px-4 mx-5 mt-8 md:w-full xl:w-1/2">
      <div class="flex items-center justify-between pb-4">
        <p class="font-medium text-lg xl:text-2xl">Détail du commerce</p>
      </div>

      <hr />

      <div class="flex my-5 gap-3">
        <i class="fa-solid fa-map-location-dot"></i>
        <div>
          <p>Adresse</p>
          <p>{{merchant?.merchant_address}}</p>
        </div>
      </div>

      <div class="flex mb-5 gap-3">
        <i class="fa-solid fa-phone"></i>
        <div>
          <p>Téléphone</p>
          <p>{{merchant?.merchant_phone}}</p>
        </div>
      </div>

      <div class="flex mb-5 gap-3">
        <i class="fa-solid fa-envelope"></i>
        <div>
          <p>Mail</p>
          <p>{{merchant?.merchant_email}}</p>
        </div>
      </div>

      <div class="flex mb-5 gap-3">
        <i class="fa-solid fa-user-tie"></i>
        <div>
          <p>Propriétaire</p>
          <p>{{merchant?.owner.user_name}}</p>
        </div>
      </div>

      <hr />

      <div class="flex justify-center gap-1 items-center">
        <p class="font-medium text-lg py-4">Horaires d'ouverture</p>
      </div>

      @for(openingHour of merchant?.openingHours; track openingHour){
        <div class="flex justify-between mb-2">
          <p>{{ openingHour?.day_of_week }}</p>
          <p>{{ formatTime(openingHour?.opening_time) | date: 'HH:mm' }} - {{ formatTime(openingHour?.closing_time) | date: 'HH:mm' }}</p>
        </div>
      }

    </div>

    <div class="bg-[#807F4B] text-white rounded-xl md:rounded-lg xl:py-10 xl:px-10 md:px-7 md:pt-7 md:pb-4 py-5 px-4 mx-5 mt-8 md:w-full">
      <div class="flex items-center justify-between pb-4">
        <div class="flex items-center gap-2 xl:gap-5">
          <i class="fa-solid fa-comment xl:text-3xl"></i>
          <p class="font-medium text-lg xl:text-2xl">Avis et commentaires</p>
        </div>
        <button (click)="openReview()" class="bg-white rounded-full py-1 px-2">
          <i class="fa-solid fa-plus text-black text-lg font-bold"></i>
        </button>
      </div>

      <hr />

      <div class="block xl:hidden">
        @for(review of merchant.reviews.slice(0, displayedReviewsCount); track review){
          <div class="py-4">
            <div class="flex gap-4 items-center">
              <app-star-rating [rating]="review.rating"></app-star-rating>
              <p>{{ review.review_date | date: 'dd/MM/yyyy' }}</p>
            </div>
            <p class="mt-4">{{ review.content }}</p>
            <div class="flex items-center gap-4 mt-4">
              <p>{{review.user.user_name}}</p>
              <img [src]="review.user.avatar" alt="avatar" class="rounded-full h-7 w-7 aspect-square object-cover" />
            </div>
          </div>
          <hr />
        }
      </div>

      <div class="hidden xl:block">
        @for(review of merchant.reviews.slice(0, displayedReviewsCountDesktop); track review){
          <div class="py-4">
            <div class="flex gap-4 items-center">
              <app-star-rating [rating]="review.rating"></app-star-rating>
              <p>{{ review.review_date | date: 'dd/MM/yyyy' }}</p>
            </div>
            <p class="mt-4">{{ review.content }}</p>
            <div class="flex items-center gap-4 mt-4">
              <p>{{review.user.user_name}}</p>
              <img [src]="review.user.avatar" alt="avatar" class="rounded-full h-7 w-7 aspect-square object-cover" />
            </div>
          </div>
          <hr />
        }
      </div>

      @if(merchant.reviews.length > displayedReviewsCount){
        <div class="flex justify-center mt-4">
          <app-button (buttonClick)="showMoreReviews()" [buttonText]="'Afficher plus'"></app-button>
        </div>
      }

    </div>
  </div>

  <div class="mt-14 bg-[#807F4B] p-4 md:p-6 xl:p-10 text-white">
    <div class="flex items-center justify-between">
      <p class="pb-3 text-lg md:text-xl">Liste des produits proposés par le commerçant</p>
    </div>
    <hr />
    <!-- Version mobile -->
    <div class="flex flex-wrap justify-center md:hidden">
      <ng-container *ngFor="let product of merchant.products; track: product">
        <div class="relative m-5 text-white">
          <img src="{{ product.product_img }}" alt="Description de votre image 1"
            class="w-52 h-80 filter brightness-65 rounded md:w-72 lg:w-80 xl:w-96 xl:h-96 object-cover" />
          <div class="absolute inset-0 flex items-end p-4">
            <p class="text-lg font-medium md:text-xl xl:text-2xl">{{ product.product_name }}</p>
          </div>
          <div class="absolute top-0 right-0 m-2">
            <i
              class="fa"
              [ngClass]="{ 'fa-heart-o': !product.liked, 'fa-heart': product.liked, 'text-orange-500': product.liked }"
              (click)="toggleWishlist(product)">
            </i>
          </div>
        </div>
      </ng-container>
    </div>
    <!-- Version Tablet Desktop -->
    <div class="hidden md:block">
      <app-carousel *ngIf="merchant.products.length > 0" [dataList]="merchant.products" [itemTemplate]="productTemplate" [customOptions]="customOptions">
        <ng-template #productTemplate let-item>
          <div class="relative mx-5 text-white mt-10">
            <img [src]="item.product_img" alt="Product Image" class="w-52 h-80 filter brightness-65 rounded md:w-72 lg:w-80 xl:w-96 xl:h-96 object-cover" />
            <div class="absolute inset-0 flex flex-col justify-end m-8">
              <p class="text-lg my-2 font-medium md:text-xl xl:text-2xl">{{ item.product_name }}</p>
            </div>
            <div class="absolute top-0 right-0 m-2">
              <i
                class="fa"
                [ngClass]="{ 'fa-heart-o': !item.liked, 'fa-heart': item.liked, 'text-orange-500': item.liked }"
                (click)="toggleWishlist(item)">
              </i>
            </div>
          </div>
        </ng-template>
      </app-carousel>
    </div>
  </div>  

  <div class="my-14 bg-[#C29667] p-4 md:p-6 xl:p-10 text-white">
    <div class="flex items-center justify-between">
      <p class="pb-3 text-lg md:text-xl">Liste des activités organisées par le commerçant</p>
    </div>
    <hr />
    <!--Version mobile-->
    @for(workshop of merchant.workshops; track workshop){
      <div class="flex justify-center my-10 flex-shrink-0 relative md:hidden" (click)="navigateToWorkshop(workshop.ID_workshop)">
        <img [src]="workshop.photos[0].url" alt="Description de votre image 1"
          class="w-52 h-80 filter brightness-65 rounded md:w-72 lg:w-80 xl:w-96 xl:h-96 object-cover" />
        <div class="absolute inset-0 flex justify-center items-center">
          <p class="text-lg font-medium md:text-xl xl:text-2xl w-1/2 text-center">{{workshop.workshop_name}}</p>
        </div>
      </div>
    }
    <!---->

    <!--Version Tablet Desktop-->
    <div class="hidden md:block">
      <app-carousel *ngIf="merchant.workshops.length > 0" [dataList]="merchant.workshops" [itemTemplate]="workshopTemplate" [customOptions]="customOptions">
        <ng-template #workshopTemplate let-item>
          <div class="relative mx-5 text-white mt-10">
            <img [src]="item.photos[0].url" alt="Product Image" class="w-52 h-80 filter brightness-65 rounded md:w-72 lg:w-80 xl:w-96 xl:h-96 object-cover" />
            <div class="absolute inset-0 flex flex-col justify-end m-8">
              <p class="text-lg my-2 font-medium md:text-xl xl:text-2xl">{{ item.workshop_name }}</p>
              <app-button [buttonText]="'Voir plus'" class="text-sm xl:text-base" (buttonClick)="navigateToWorkshop(item.ID_workshop)"></app-button>
            </div>
          </div>
        </ng-template>
      </app-carousel>
    </div>
    <!---->
  </div>

  @if(latitude && longitude){
  <div class="m-5 pb-10 z-0 lg:mx-16 xl:mx-40">
    <div class="flex justify-between items-center pb-3">
      <p class="text-lg md:text-xl xl:text-2xl">Localisation</p>
    </div>
    <hr />
    <div class="flex gap-3 py-3">
      <i class="fa-solid fa-location-dot"></i>
      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore
        magna aliqua.</p>
    </div>
    <div class="h-80 md:h-96 lg:h-96 py-3">
      <app-leaflet-map [latitude]="latitude" [longitude]="longitude" [showMarker]="true"></app-leaflet-map>
    </div>
  </div>
  }
</div>

<app-gallery [isOpen]="isGalleryOpen" [images]="photoUrls" (closeGallery)="isGalleryOpen = false"></app-gallery>

<app-modal [isOpen]="isReviewOpen" [title]="'Ajouter un commentaire'" (closed)="closeReview()">
  <div>
    <form [formGroup]="reviewForm">
      <div class="mb-4">
        <label for="rating" class="block text-gray-700 text-sm font-bold mb-2">Note:</label>
        <app-star-rating [rating]="reviewForm.controls['rating'].value" [editable]="true" (ratingChange)="reviewForm.controls['rating'].setValue($event)"></app-star-rating>
      </div>
      <div class="mb-4">
        <label for="content" class="block text-gray-700 text-sm font-bold mb-2">Commentaire:</label>
        <textarea id="content" formControlName="content" required class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"></textarea>
      </div>
      <div class="flex items-center justify-between">
        <button type="submit" (click)="submitReview()" class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline" [disabled]="reviewForm.invalid">
          Ajouter
        </button>
      </div>
    </form>
  </div>
</app-modal>

<app-spinner [loading]="isLoading"></app-spinner>
<app-popup [message]="successMessage" [duration]="5000"></app-popup>